// bibliDlg.cpp : implementation file
//

#include "stdafx.h"
#include "bibli.h"
#include "bibliDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBibliDlg dialog

CBibliDlg::CBibliDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBibliDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBibliDlg)
	m_emp_rtype = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBibliDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBibliDlg)
	DDX_Control(pDX, EMP_NO, m_emp_no);
	DDX_Control(pDX, LIV_ISBN, m_emp_isbn);
	DDX_Control(pDX, LIV_TITRE, m_liv_titre);
	DDX_Control(pDX, EMP_VILLE, m_emp_ville);
	DDX_Control(pDX, EMP_CP, m_emp_cp);
	DDX_Control(pDX, EMP_RNOM, m_emp_rnom);
	DDX_Control(pDX, EMP_PRENOM, m_emp_prenom);
	DDX_Control(pDX, EMP_NOM, m_emp_nom);
	DDX_CBString(pDX, EMP_RTYPE, m_emp_rtype);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBibliDlg, CDialog)
	//{{AFX_MSG_MAP(CBibliDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(EMP_ADD, OnEmpAdd)
	ON_BN_CLICKED(EMP_SUP, OnEmpSup)
	ON_BN_CLICKED(EMP_MOD, OnEmpMod)
	ON_BN_CLICKED(LIV_ADD, OnLivAdd)
	ON_BN_CLICKED(LIV_SUP, OnLivSup)
	ON_BN_CLICKED(ID_QUIT, OnQuit)
	ON_CBN_SELCHANGE(LIV_TITRE, OnSelchangeTitre)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBibliDlg message handlers

BOOL CBibliDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

    /* -------------------------------------------------
	 * Creation bib
	 * -------------------------------------------------
	 */
  	 myBib = new Bibliotheque();


	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBibliDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBibliDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBibliDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBibliDlg::OnEmpAdd() 
{
	// TODO: Add your control notification handler code here
	
}

void CBibliDlg::OnEmpSup() 
{
	// TODO: Add your control notification handler code here
	
}

void CBibliDlg::OnEmpMod() 
{
	// TODO: Add your control notification handler code here
	
}




void CBibliDlg::OnQuit() 
{
	// TODO: Add your control notification handler code here
	CDialog::OnCancel();	
}

//////////////////////////////////////////////////////////////////
// GESTION DES LIVRES
//////////////////////////////////////////////////////////////////

void CBibliDlg::OnLivAdd() 
{
	// TODO: Add your control notification handler code here

    // Verifie le format de la chaine
	CString isbn;
	m_emp_isbn.GetWindowText(isbn);
    for ( int i = 0 ; i < isbn.GetLength() ; i++ ) {
		if ( !(isbn[i] > '0' && isbn[i] < '9') && isbn[i] != '-' )
			break;
	}
	if ( i < isbn.GetLength() ) {
		MessageBox(_T("Format Isbn incorrect"),
			       _T("Isbn incorrect"),
				   MB_ICONERROR | MB_OK );
	} else {
      CString titre;
	  m_liv_titre.GetWindowText(titre);

      if ( myBib->ajouterLivre(titre,isbn) == false ) {
	  	 // Creation d'une fenetre pour prevenir de l'erreur
	     MessageBox(_T("Impossible d'ajouter ce livre"),
		 	 	    _T("Titre incorrect"),
				    MB_ICONERROR | MB_OK );
	  } else {
         myBib->creerListLivre(&m_liv_titre);
	     m_emp_isbn.SetWindowText("");
	  }
	}
}

void CBibliDlg::OnLivSup() 
{
	// TODO: Add your control notification handler code here
    CString titre;
	if ( m_liv_titre.GetCurSel() != CB_ERR ) {
 	   m_liv_titre.GetLBText(m_liv_titre.GetCurSel(),titre);

	   CString isbn = myBib->donnerIsbnFromTitre(titre);
       if ( myBib->supprimerLivre(isbn) == false ) {
	   	  MessageBox(_T("Ce livre n'existe pas"),
		  	         _T("Suppression impossible"),
				     MB_ICONERROR | MB_OK );
	   } else {
		  myBib->creerListLivre(&m_liv_titre);
	      m_emp_isbn.SetWindowText("");
	   }
	}
}

void CBibliDlg::OnSelchangeTitre() 
{
	// TODO: Add your control notification handler code here
    CString titre;
  	m_liv_titre.GetLBText(m_liv_titre.GetCurSel(),titre);

	CString isbn = myBib->donnerIsbnFromTitre(titre);
    m_emp_isbn.SetWindowText(isbn);		
}


